<template>
  <div class="modal" v-if="state.modal.show">
    <div class="contentWrapper">
      <div class="message" v-if="state.modal.message">
        {{ state.modal.message }}
      </div>
      <div
        class="input"
        v-for="(field, index) in state.modal.data"
        :key="index"
      >
        <span>{{ field.label }}</span>
        <input type="text" v-model="state.modal.data[index].value" required />
      </div>
      <div class="actions">
        <button class="secondary" @click="closeModal">Close</button>
        <button @click="addPage">Create</button>
      </div>
    </div>
  </div>
  <div class="hello">
    <div class="container">
      <div class="list">
        <div v-for="page in pages" :key="page.page_slug" class="item">
          <div>
            <div class="main" v-if="page.page_url == '/'">
              <Icon size="32px" src="home" color="var(--color)" />
            </div>
            <div class="name">{{ page.page_slug }}</div>
          </div>
          <div class="actions">
            <router-link class="action" :to="`/admin/pages/${page.page_slug}`">
              <span>Редактировать</span>
              <Icon size="32px" src="edit" color="var(--color)" />
            </router-link>
            <div class="action">
              <span>Ссылка</span>
              <Icon size="32px" src="link" color="var(--color)" />
            </div>
            <div class="action">
              <span>Настройки</span>
              <Icon size="32px" src="cog" color="var(--color)" />
            </div>
            <div
              @click="
                () => {
                  delPage(page.page_slug);
                }
              "
              class="action"
            >
              <span>Удалить</span>
              <Icon size="32px" src="delete" color="var(--color)" />
            </div>
          </div>
        </div>
        <button @click="openModal" class="addItem">
          <Icon class="icon" size="16px" src="plus" color="var(--color)" />
          Добавить новую страницу
        </button>
      </div>
    </div>
  </div>
</template>

<script>
import { computed, onBeforeMount, reactive } from "vue";
import { useStore } from "vuex";
import Icon from "ac/Icon";
export default {
  components: { Icon },
  setup() {
    const store = useStore();
    const state = reactive({
      modal: {
        show: false,
        data: {
          page_slug: {
            value: "",
            label: "Название",
          },
          page_url: {
            value: "",
            label: "URL",
          },
        },
        message: "",
      },
    });

    onBeforeMount(async () => {
      store.dispatch("pages/getData");
    });

    return {
      pages: computed(() => store.getters["pages/getAllPages"]),
      state,
    };
  },
  methods: {
    addPage() {
      if (this.state.modal.data.page_slug.value && this.state.modal.data.page_url.value) {
        this.$store.dispatch("pages/createPage", {
          page_slug: this.state.modal.data.page_slug.value,
          page_url: this.state.modal.data.page_url.value,
        });
        this.state.modal.show = false;
      } else {
        this.state.modal.message = "Вы ввели не все данные";
      }
    },
    delPage(page_slug) {
      console.log(
        this.$store.dispatch("pages/deletePage", {
          page_slug,
        })
      );
    },
    closeModal() {
      this.state.modal.show = false;
    },
    openModal() {
      this.state.modal.show = true;
    },
  },
};
</script>

<style scoped lang="scss">
.modal {
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  position: fixed;
  background: #00000090;
  z-index: 11;

  display: flex;
  align-items: center;
  justify-content: center;

  .contentWrapper {
    background: #ffffff;
    border-radius: 8px;
    height: auto;
    width: 320px;
    overflow-y: auto;
    max-height: 640px;
    padding: 20px;

    .message {
      padding: 8px;
      background: var(--secondary-light-2-color);
      color: var(--secondary-dark-1-color);
      margin-bottom: 12px;
      border-radius: 4px;
    }

    .input {
      display: flex;
      margin-bottom: 8px;

      > *:nth-child(1) {
        flex: 0.3;
      }
      > *:nth-child(2) {
        flex: 0.7;
      }
    }

    .actions {
      display: flex;
      justify-content: flex-end;

      > *:not(:last-child) {
        margin-right: 8px;
      }

      button {
        border: none;
        padding: 8px 16px;
        background: var(--primary-color);
        border-radius: 4px;
        color: white;

        &:hover {
          background: var(--primary-dark-1-color);
        }

        &:active {
          background: var(--primary-dark-2-color);
        }
      }

      .secondary {
        background: var(--secondary-color);

        &:hover {
          background: var(--secondary-dark-1-color);
        }

        &:active {
          background: var(--secondary-dark-2-color);
        }
      }
    }
  }
}

.container {
  display: flex;
  flex-wrap: wrap;
  margin: 0 -16px;

  .list {
    width: 100%;
    padding: 8px;

    > *:not(:last-child) {
      margin-bottom: 8px;
    }
  }

  .item {
    display: flex;
    justify-content: space-between;
    padding: 8px;
    background: #ffffff;

    > div {
      display: flex;
      align-items: center;
    }

    .main {
      margin-right: 8px;
      --color: #000000;
    }

    .name {
      font-size: 21px;
      text-transform: capitalize;
    }

    .action {
      display: flex;
      align-items: center;
      cursor: pointer;

      color: #000000;
      --color: #000000;

      &:hover {
        color: var(--primary-color);
        --color: var(--primary-color);
      }

      &:not(:last-child) {
        margin-right: 16px;
      }

      > span {
        display: block;
        align-items: center;
        font-size: 16px;
      }
    }
  }

  a {
    text-decoration: none;
    color: inherit;
  }
}

.addItem {
  cursor: pointer;
  display: flex;
  align-items: center;
  justify-content: center;
  margin: 0 auto;
  border: none;
  background: white;
  border-radius: 10px;
  transition: all 0.3s ease;
  --color: black;
  color: var(--color);
  outline: none;
  padding: 8px 16px;

  &:hover {
    --color: var(--primary-color);
  }

  &:active {
    --color: var(--primary-dark-1-color);
  }

  .icon {
    margin-right: 12px;
  }
}
</style>
